
package AS.Cliente.Gui;

import java.awt.*;
import AS.Cliente.*;
import AS.*;
import java.awt.event.*;

public class ClientGui extends Frame implements WindowListener,ActionListener{
  GridBagLayout gridBagLayout = new GridBagLayout();
  Label userLabel = new Label("Inserire nome Utente da ricercare");
  TextField userField = new TextField();
  Button cercaButton = new Button("Cerca");
  TextArea msgArea = new TextArea();
  Button inviaButton = new Button("Invia");
  Label outputLabel = new Label();
  Label msgLabel = new Label("Inserire Messaggio");

	Client cli;
	BtoA btoa=null;
	
  public ClientGui(Client cli,String id) {
    this.cli=cli;
		setTitle(id);
		addWindowListener(this);
		this.setSize(new Dimension(500, 350));
    this.setLayout(gridBagLayout);
    this.add(userLabel, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 2, 5), 0, 0));
    this.add(userField, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 20, 5), 0, 0));
    cercaButton.addActionListener(this);
		this.add(cercaButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 20, 5), 0, 0));
    this.add(msgArea, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 20, 0), 0, 0));
    inviaButton.addActionListener(this);
		this.add(inviaButton, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 20, 5), 0, 0));
    this.add(outputLabel, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 2, 2, 0), 0, 0));
    this.add(msgLabel, new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 5, 2, 5), 0, 0));
  	msgArea.setEditable(false);
		inviaButton.setEnabled(false);
	}
	
	public void windowClosing(WindowEvent evt){
		dispose();
		System.exit(0);
	}//windowClosing
	
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}
	
	public void actionPerformed(ActionEvent e){
		String command=e.getActionCommand();
		if(command.equals("Cerca")){
			String name=userField.getText();
			btoa=cli.parti(name);
			if(btoa==null)
				outputLabel.setText("Impossibile attivare comunicazione.");
			else{
				outputLabel.setText("Comunicazione attivata, inserire messaggio.");
				msgArea.setEditable(true);
				inviaButton.setEnabled(true);
				cercaButton.setEnabled(false);
				userField.setEditable(false);
			}
		} else {
			//System.out.println("btoa!!!!!!!!!!!="+btoa);
			if(btoa!=null){
				String msg=msgArea.getText();
				btoa.trasmetti(msg);
				cercaButton.setEnabled(true);
				userField.setEditable(true);
				msgArea.setEditable(false);
				inviaButton.setEnabled(false);
				msgArea.setText("");
				outputLabel.setText("Messaggio inviato.");
			}
		}
	}
}

