package AS.Cliente;


import java.io.*;
import java.net.*;
import AS.Util.*;
import java.util.Hashtable;

import java.security.Signature;

import iaik.security.rsa.*;
//import java.security.*;
import com.entrust.util.*;
import java.lang.Object;
import Msg.PacketMsg;		  //notFindMsg    requestMsg   answerMsg
import AS.Msg.*;
//import java.util.Random;
import AS.DtgRichiesta;
//import AS.codtab;
import Security.chiave;


public class cli {
static transient Socket clientSocket1;
RSAPrivateKey kPr;
RSAPublicKey kPb;
connettiTCP conn;
 
public cli(indirizzo adr,RSAPrivateKey kPr,RSAPublicKey kPb){
  	this.kPr=kPr;
	this.kPb=kPb;
	try
    {
     clientSocket1 =new Socket(adr.getadr(),adr.getport());	
	  System.out.println("creata socket");
	  //hostPort=legatiaporta();
    }
   catch (Exception e) {
     System.out.println("Exception: " + e);
    }
  }

public cli(connettiTCP conn,RSAPrivateKey kPr,RSAPublicKey kPb){
	this.conn=conn;
  	this.kPr=kPr;
	this.kPb=kPb;
	
	
  }

public static void main(String args[]) {       
   RSAPrivateKey kPr1=null;
	RSAPublicKey kPb1=null;
	try
	 {costanti cns = new costanti();
	  chiave keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
	  kPr1=keyS.getPrivate();
 	  kPb1=keyS.getPublic();
	  InetAddress hostAddress = InetAddress.getLocalHost();
	  indirizzo adr =new indirizzo(hostAddress,4000);
	  connettiTCP conn1 = new connettiTCP(adr);
	  cli c=new cli(conn1,kPr1,kPb1);
     Hashtable ht=(Hashtable)c.RxService(); 
	  if (ht.isEmpty())System.out.println(" hashtable vuoto");
	  }//endtry
	
	catch (Exception e) {
     System.out.println("Exception: " + e);
    }
	
}


public Hashtable RxService() throws Exception
{								 //Qusta funzione attende un intero "size" che  la dimensione dell'Hashtable
								 //Successivamente legge e verifica una per una le entry dell'Hashtable che
								 //gli vengono inviate (singolarmente, codificate, con un timestamp di 
								 //controllo che ne assicuri la freschezza
								 //per ultimo restituisce l' Hashtable ricevuto se consistente
								 //o uno vuoto se si sono verificati dei problemi

	Hashtable table =new Hashtable();

	try
	{int k=0,v=0;
	boolean first=true;
	boolean tuttook=true; 
	
	//ObjectInputStream in = new ObjectInputStream(clientSocket1.getInputStream());
	int c=(int)conn.attendiRispostaInt();		  //size hashtable
	//in questo ciclo viene effettuato il controllo sulla consistenza del
	//messaggio (mediante la signature) successivamente si controlla che il 
	//timestamp sia coerente con il valore del msg precedentemente ricevuto
	//se tutto questo  ok si puo proseguire altrimenti si lancia un msg err

	do{		k++;
				//System.out.print("  "+k++);	   //attenzione qui effettuo incremento
	
				entryKey rka=(entryKey)conn.attendiRisposta();
	
				byte[] signaaa=rka.getsign();
				boolean okaa=rka.verifica(signaaa,kPb);
				entry ey = (entry) rka.getObj();
				System.out.print("ok?  "+okaa+" ricevuto "+ey.getname());
				if (!okaa) {tuttook=false; System.out.println("signature not correct ");}
				if (first) {v=(int) ey.getcount(); first=false; System.out.println(" ");}
				else if ((++v)!=(int) ey.getcount()) {tuttook=false; System.out.println("no coincidenza timestamp ");}
					  else System.out.println(" timestamp correct");
				table.put(ey.getname(),ey.getkey());
	}while((k<c) && tuttook);

	//si invia al Gestore l'ultimo timestamp letto INCREMENTATO come prova della validita dei msg
	if(tuttook){ 
		//System.out.println("sono qua      v    "+v);
		tistamp tms=new tistamp(v);					//invece di c
		msgFirma firma3=new msgFirma(tms);
		byte[] sign3 = firma3.autentica(kPr);
		tstsign tst=new tstsign(tms,sign3);
		//ObjectOutputStream out = new ObjectOutputStream(clientSocket1.getOutputStream());
		//out.writeObject(tst);
		conn.inviaMsg(tst);
		System.out.print("inviato tmp conferma   ");
		}
	else{
		tistamperr tms=new tistamperr();
		msgFirma firma3=new msgFirma(tms);
		byte[] sign3 = firma3.autentica(kPr);
		tstsign tst=new tstsign(tms,sign3);
		//ObjectOutputStream out = new ObjectOutputStream(clientSocket1.getOutputStream());
		//out.writeObject(tst);
		conn.inviaMsg(tst);
		System.out.print("inviato tmp err  ");
		table=new Hashtable();    //in caso di errore non devo restituire nessun hashtable
		}
		for (int x=0; x<10000;x++) {int j=0; do{j++;}while(j<30000); }	  
											//aspetto un tempo limitato (circa 2 sec) per permettere al Server 
										  //di leggere il dato prima della chiusura della connessione
	}	
	catch (SocketException e)   {
    throw e;
	}
	catch(EOFException e){
	throw e;
	}
	catch (Exception ioe)   {
    System.out.println("Errore : " + ioe);  table=new Hashtable();
	}
	return table;
}
}
