package AS;


import java.io.*;
import java.net.*;
import java.lang.String;
import java.net.DatagramSocket;
import java.net.MulticastSocket;
import Msg.PacketMsg;
import AS.Util.*;
import Security.chiave;
import AS.Msg.*;


public class DtgRichiesta 
{
    private DatagramSocket clientsocketDtg = null;              
    private DatagramPacket recvPacket, sendPacket;
    int hostPort; 
    InetAddress hostAddress;                               
    requestKey msg;
    public static final int timeout = 30000; //TIMEOUT SU RECEIVE 7 sec
 
  public DtgRichiesta(indirizzo adr, requestKey msg) 
    	{this.hostPort=adr.getport();
		 this.hostAddress=adr.getadr();
       this.msg=msg;
		 //PER LA COMUNICAZIONE CON LE COPIE CONTIENE IL NOME DEL CLIENTE DA RICERCARE
	 	 } //costruttore 
	  
  

  public  Object InviaRicevi()		 //INVIA E RICEVE UN Object
    {
        DatagramSocket clientsocketDtg = null;
        DatagramPacket  sendPacket,recvPacket =null;
        Object o = null;
        try	{	
		//creazione socket datagram per client; viene omesso il numero di porta,
		// il SO assegna il primo numero di porta disponibile
            clientsocketDtg = new DatagramSocket();
				//ottengo l'indirizzo dell'host locale
          	//InetAddress hostAddress = InetAddress.getByName("localhost");
		
				if (clientsocketDtg != null){
					//byte sendbuf[] = msg.getBytes();
					//hostaddress  indirizzo del mittente
					//hostPort  la porta del Server
					//sendPacket= new DatagramPacket(sendbuf, sendbuf.length, hostAddress, hostPort);			
					
					
					sendPacket = msg.writeToPacket(hostAddress, hostPort);
					
					clientsocketDtg.send( sendPacket ); 	//INVIATO PACCHETTO A COPIA

        			System.out.println(" inviato pacchetto ");
               
					//INIZIALIZZAZIONE DEL TIMEOUT
					clientsocketDtg.setSoTimeout(timeout);
			 		
					//ATTESA RX PACCHETTO  DA COPIA
					recvPacket= new DatagramPacket(new byte[1024], 1024);
           		clientsocketDtg.receive(recvPacket); //RX PACCHETTO o TIMEOUT
					
					// IL PACCHETTO CONTERR SICURAMENTE UN msgUDP, ANSWER o NOTFIND
					/**NOTA:
					  *      requestMsg long 120 byte  ===>>>
					  *      answerMsg  long 726 byte  <<<===
					  *      notFindMsg long  84 byte  <<<===
					  *		timeoutMsg long  84 byte  <<<===
					  **/

					System.out.println("ricevuto pacchetto   ");
					//System.out.write(recvPacket.getData(), 0, recvPacket.getLength());
					//System.out.print("\r\n");
					
		 			o =(Object)msgUDP.readFromPacket(recvPacket);
					 
					
            } //endif
		
         }//endtry
  	catch (SocketException e) {
            System.out.println("Errore SocketException:     " +  e);
         }   
 	catch (InterruptedIOException e) {
            //System.out.println("Errore:     " +  e);
				System.out.println("Receive timed out");
				timeoutMsg risposta = new timeoutMsg(5);
				o =(Object)risposta;
			 } 
			
			catch (IOException e) {
            System.out.println("Errore IOException:     " +  e);
         }   
	  
	catch (Exception e) {
            System.out.println("Errore:     " +  e);
         }   
 	// eccezioni possibili NumberFormatException,SocketException,IOException
       
   return  o;
} //endInviaRicevi



  public static void main (String args[]){
		DtgRichiesta DC=null;
		Object risp=null;
		chiave keyS= null;
		if(args.length!=2) {
			System.err.println("usage: java DtgRichiesta port_number  msg\n");
			System.exit(1);
		}
		try{
			//REPERIMENTO DELLE CHIAVI DEL SERVER
			costanti cns = new costanti();
			keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
			//keyS=new chiave("D:/Utenti/stefano/progetto/java/javaprova/keyprServer.txt","D:/Utenti/stefano/progetto/java/javaprova/keypbServer.txt");
			
			}
			catch( Exception e){
				System.out.println("Errore reperimento chiavi Server :"+e.getMessage()); 
				System.exit(1);}



		  //arg: 1- msg,  2- timestamp gestore
		try{  requestMsg r =new requestMsg(args[1],3);
			 	msgFirma firma=new msgFirma(r);
				byte[] sign = firma.autentica(keyS.getPrivate());  
				requestKey req = new requestKey(r,sign);							  //creo un requestKey
			  //arg: 1- porta 2- requestMsg
			   InetAddress hostAddress1 = InetAddress.getLocalHost();
				indirizzo adr =new indirizzo(hostAddress1,(Integer.valueOf(args[0])).intValue());
		  		DC= new DtgRichiesta(adr,req);	   //invio un requestKey
			} 		
		catch(NumberFormatException e){
				System.out.println("port_number must be an integer\n");
				System.exit(1);
		}
		catch(Exception e){
				System.out.println("errore"+e);
				System.exit(1);
		}
		System.out.println("tutto ok invioricevo");
		if(!DC.equals(null)) risp =(Object)DC.InviaRicevi();						  //ricevo un oggetto
		 if (risp instanceof answerKey) {answerKey r = (answerKey)risp;
		 											answerMsg req =(answerMsg) r.getObj();
		 										   System.out.println("tutto ok fine  a   n. "+req.getN());}
		 if (risp instanceof notFindKey){notFindKey r = (notFindKey)risp;
		 											notFindMsg req =(notFindMsg) r.getObj();
		 										   System.out.println("tutto ok fine  a   n. "+req.getN());}
		 if (risp instanceof timeoutMsg)System.out.println("tutto ok fine  t   n. "+((timeoutMsg)risp).getN());
		 if (risp instanceof refuseMsg) System.out.println("tutto ok fine  r   n. "+((timeoutMsg)risp).getN());
	}
}
//restituisce null se la receive non ha avuto successo
