package AS.Msg;


import java.security.*;//Signature;
//import iaik.security.rsa.ShaRSASignature;
import iaik.security.rsa.*;
//import java.security.*;
import com.entrust.util.*;
import java.lang.Object;


import java.io.*;

public class msgFirma extends Msg.PacketMsg implements Serializable{
	
	protected Object obj;     	//signature
	
	
	//costruttore:
	public msgFirma(Object obj){
		
		this.obj=obj;
	
	}
public Object getObj(){
		return obj; 
	}
   
	public byte[] autentica(RSAPrivateKey keyPrivate){
	byte[] signature = null;
	try{
	
		//Costruzione flusso di byte per ottenere signature
		ByteArrayOutputStream abyte = new ByteArrayOutputStream();
		ObjectOutputStream outbyte = new ObjectOutputStream(abyte);
		outbyte.writeObject(obj);
		byte[] objbyte = abyte.toByteArray();

		Util.initCiphers();
		Signature hash_rsa = Signature.getInstance("SHA/RSA");
   	//   Initialize for Signing:
		 
   	hash_rsa.initSign(keyPrivate); 	 //KeyS.getPrivate()
   
   	hash_rsa.update(objbyte);
   	signature = hash_rsa.sign();
	}//endtry
	catch( Exception e){
	System.out.println("Errore autentica msgFirma:"+e.getMessage()); System.exit(3); }
		return signature;
} //endautentica

	public boolean verifica(byte[] signature,RSAPublicKey keyPublic){
	 boolean ok =false;
	
	try{  
			//TRASFORMAZIONE DELL' oggetto IN FLUSSO DI BYTE
			ByteArrayOutputStream abyte = new ByteArrayOutputStream();
			ObjectOutputStream outbyte = new ObjectOutputStream(abyte);
			outbyte.writeObject(obj);
			byte[] objbyte = abyte.toByteArray();
		   
			Util.initCiphers();
			Signature hash_rsa = Signature.getInstance("SHA/RSA"); 
   		
			//   Initialize for Verifying: 							 //VERIFICA CONSISTENZA TABELLA
			hash_rsa.initVerify(keyPublic); 
			
  	 		hash_rsa.update(objbyte);
			
			ok=hash_rsa.verify(signature);
			
		}//endtry
		catch( InvalidKeyException e){
						System.out.println("Errore verifica msgFirma:InvalidKeyException"+e.getMessage()); System.exit(3); }
  		//System.out.println("Signature " + (hash_rsa.verify(sign) ? "correct!" : "not correct!"));
	 catch( Exception e){
						System.out.println("Errore verifica msgFirma:"+e.getMessage()); System.exit(3); }
		return ok;
	
	
	
	}//endverifica

	
}//endtabella
