package AS;



import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import Msg.PacketMsg;
import java.security.Signature;
import iaik.security.rsa.*;
//import iaik.security.rsa.RSASignature;
//import com.entrust.util.*;
import Security.chiave;
import AS.Util.*;
import Exceptions.*; //InexistanceFileException;
import AS.Msg.*;

class Sht {						  //fz Server di aggiornamento e verifica consistenza hashtable
connettiTCP conn =null;		  //il primo passo  la lettura dell'Hashtable da file
transient Socket client;	  //viene inviato la dimensione della tabella da lleggere
RSAPrivateKey kPr;			  //ogni singola entry viene poi firmata e spedita
RSAPublicKey kPb;				  //infine si riceve l'ultimo timestamp letto dalla copia
									  //(e quindi la dim dell'hashtable). qusto msg serve per 
									  //verificare che effettivamnete le entry della copia non 
									  //siano TUTTI msg vecchi intercettati e riutilizzati

	 public Sht(Socket client,RSAPrivateKey kPr,RSAPublicKey kPb){
	 	this.client=client;
		this.kPr=kPr;
		this.kPb=kPb;
		
		}
	  public Sht(connettiTCP conn,RSAPrivateKey kPr,RSAPublicKey kPb){
	 	this.conn=conn;
		this.kPr=kPr;
		this.kPb=kPb;
		
		}
    public static void main(String args[])
    {	  
        ServerSocket serverSocket = null;
        Socket clientSocket = null;
        RSAPrivateKey kPr1=null;
		  RSAPublicKey kPb1=null;
        try
        {
            // Create the server socket
            serverSocket = new ServerSocket(4000);		/*	crea un socket server e lo lega alla porta 2000  	 */	
          	System.out.println("sono in attesa");
				clientSocket = serverSocket.accept();
				System.out.println("Effettuata accept");
            //Si genera quindi un nuovo socket usata per la comunicazione con il cliente
				//REPERIMENTO DELLE CHIAVI DEL SERVER
				costanti cns = new costanti();
				chiave keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
				        
				
		 		kPr1=keyS.getPrivate();
 		   	kPb1=keyS.getPublic();

				connettiTCP conn1 = new connettiTCP(clientSocket);
				//ServiceCopia(clientSocket,kPr,kPb);
				
				Sht sht=new Sht(conn1,kPr1,kPb1);					//
				boolean vero=sht.ServiceCopia(); 					//
				//////////////////////////////////////////////////
				
				System.out.println("ricevuto    "+vero);
            serverSocket.close();
        }  //endtry
        catch (Exception ioe)  {
            System.out.println("Errore in Sht: " + ioe.getMessage());
        }
		  
    }//endmain

    public  boolean ServiceCopia() throws Exception	//restituisce true se  andato tutto bene:   
    {boolean oK=true;											//il size di ritorno coincide e non si sono
	  Hashtable ht;
	  try{															//verificati msg di errore
		costanti cns = new costanti();
  		// leggo Hashtable  
   	try{
  			ht =(Hashtable)readHashtable(cns.getHT());
		}
		catch( Exception e){
		throw new InexistanceFileException("file inesistente");
		} 
		//ObjectOutputStream out = new ObjectOutputStream(client.getOutputStream());
				
						
				int k=0;
				int tsg=Rtimestamp();
				int sz=ht.size();	  
				conn.inviaMsgInt(sz);
				
				for (Enumeration e = ht.keys() ; e.hasMoreElements() ;) {
              String name=(String)e.nextElement();
				  RSAPublicKey pkb = (RSAPublicKey)ht.get(name);
				  //System.out.println(name);

      		
				System.out.println(" entry      "+(tsg++)+"       "+name);		  //incremento tsg!!!!!!!
				//System.out.println(" 1 "); 
  			      int j=0;
					do{j++;}while(j<5000);		   //ATTESA?????
				//invio Entry dell Hashtable
				//System.out.println("entry");
					entry r1a =new entry(name,pkb,tsg);
					msgFirma firma1=new msgFirma(r1a);
					byte[] sign1 = firma1.autentica(kPr);  
					entryKey reqa = new entryKey(r1a,sign1);
					//out.writeObject(reqa);
					conn.inviaMsg(reqa);
          } //endfor;
					//System.out.println(" 2 "); 
					
					 //ora dopo l'invio delle entry attendo il ricevimento di un oggetto 
					 //indicativo del size dell' HT. ricevo l'ultimo timestamp che ho 
					 //inviato alla copia, INCREMENTATO
						
						tstsign tst=(tstsign)conn.attendiRisposta();
						byte[] signaaa=tst.getsign();
						oK=tst.verifica(signaaa,kPb);
						//il campo oK qui mi indica se il messaggio  consistente ovvero
						//se non ha subito modifiche

						//eseguo quindi il controllo sul contenuto del msg  cio viene controllato che
						//l'ultimo timestamp letto dalla copia sia lo stesso inviato dal Gestore
						// un ulteriore prova di freschezza del msg
						System.out.println("ok?  "+oK);
						if (oK){ 
						  System.out.println("  ricevuto  tmp conferma  "+((tistamp)tst.getObj()).getN());
						  //System.out.print("tsg?  "+tsg);
						  if (tst.getObj()instanceof tistamperr) oK=false; 
						  if ( (!(tst.getObj() instanceof tistamp)) || (!(((tistamp)tst.getObj()).getN()==tsg)) ) {
						  				oK=false; 
										System.out.println(" tmp conferma not correct!  ");}  //il msg non  fresh!!!!!!!!!!
						  }
					System.out.println("trasmissione Hashtable oK?  "+oK);
					//do{}while(true);
	  
	  
					
	}//endtry

	catch( Exception e){
		//System.out.println("Errore :"+e.getMessage()); oK=false;
 	   throw e;
		} 
return oK; 
}


public int Rtimestamp(){
 Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
 int timestamp = Math.abs(nran.nextInt())%1000;
 return timestamp;
 }

public static  Hashtable readHashtable(String nomefile) throws Exception{
		FileInputStream istream = new FileInputStream(nomefile);
		ObjectInputStream p = new ObjectInputStream(istream);
		Hashtable ht=(Hashtable)p.readObject();
		istream.close();
		p.close();
		return ht;
	}

 }
