package AS.Util;


import java.io.*;
import java.net.*;
import java.lang.Object;
import java.lang.Exception;
import java.util.Hashtable;


public class connettiTCP {
	Socket msgSocket;
   ObjectOutputStream out=null; 
	ObjectInputStream in=null;

 	// costruttore 1 gli vien passata la socket -lato server- socket di comunicazione
  
   public connettiTCP(Socket msgSocket){
		this.msgSocket = msgSocket;
		///
		try
        {
     	  	out = new ObjectOutputStream(msgSocket.getOutputStream());
     		in = new ObjectInputStream(msgSocket.getInputStream());
   }
     catch(SocketException e){
		System.err.println("Errore in creazione Socket:"+e.getMessage());
		}
	catch (IOException ioe) {
            System.out.println("Errore in Socket: " + ioe);
        }

		///
		
		} //endconnettiTCP -costruttore 1-

	//costruttore 2 crea la socket -lato Client-
  public connettiTCP(indirizzo adr) throws Exception
    {
     try
        {
        // Apre una connessione Socket Client
	  msgSocket =new Socket(adr.getadr(),adr.getport());	
	  System.out.println("creata socket");
	  out = new ObjectOutputStream(msgSocket.getOutputStream());
     in = new ObjectInputStream(msgSocket.getInputStream());
   }
     catch(SocketException e){
		System.err.println("impossibile connettersi: nessuno in ascolto   ");
		throw e;
		}
	catch (IOException ioe) {
            System.out.println("Errore in Socket: " + ioe);
				throw ioe;
        }

    }//endconnettiTCP -costruttore 2-

public void inviaMsg(Object msg){
	//ObjectOutputStream out=null;
	try
	{     
			//System.out.println("Acquisiti flussi Output");
   		out.writeObject(msg);
			System.out.println("inviato oggetto");
			//out.close();
	}//endtry
	catch (InvalidClassException  e){
		System.err.println("Errore in inviaMsg 1:"+e.getMessage());
	}
	catch (NotSerializableException  e){
		System.err.println("Errore in inviaMsg 2:"+e.getMessage());
	}
	catch ( IOException  e){
		System.err.println("Errore in inviaMsg 3:"+e.getMessage());
	}
								//se msg =null >>>>?????
}//end inviaMsg 

public void inviaMsgInt(int t){
	//ObjectOutputStream out=null;
	try
	{     
			//System.out.println("Acquisiti flussi Output");
   		out.writeInt(t);
			out.flush();
			System.out.println("inviato size");
			//out.close();
	}//endtry
	catch (InvalidClassException  e){
		System.err.println("Errore in inviaMsgInt 1:"+e.getMessage());
	}
	catch (NotSerializableException  e){
		System.err.println("Errore in inviaMsgInt 2:"+e.getMessage());
	}
	catch ( IOException  e){
		System.err.println("Errore in inviaMsgInt 3:"+e.getMessage());
	}
								//se msg =null >>>>?????
}//end inviaMsg 


  


public Object attendiRisposta() throws Exception{
	Object msg=null;
	//ObjectInputStream in=null;
	try
	{     //acquisisce i flussi diInput
			//System.out.println("Acquisiti flussi input");
	    	//in = new ObjectInputStream(msgSocket.getInputStream());
      	msg=(Object)in.readObject();
			//System.out.println("ricevuto oggetto attendirisposta");		 // ricevuto oggetto attendirisposta
			//in.close();
	}//endtry
	catch(EOFException e){
		//System.err.println("Errore in EOFException:"+e.getMessage());
		throw e;}
	catch (IOException ioe) {
            System.out.println("nessuna risposta");
			   throw ioe;}
	//catch(SocketException e){
//		System.out.println("Errore in attendiRisposta: "+e.getMessage());
//		}
	return msg;
}//endattendiRisposta  

public int attendiRispostaInt() throws Exception{
	
	int c=0;
	try
	{     //acquisisce i flussi diInput
		
      	c=(int) in.readInt();
			System.out.println("ricevuto size attendirispostInt");
			//in.close();
	}//endtry
	catch(EOFException e){
		//System.err.println("Errore in EOFException:"+e.getMessage());
		throw e;}
	catch (IOException ioe) {
            System.out.println("nessuna risposta"); 
				throw ioe;}
	catch(Exception e){
		System.err.println("Errore in attendiRispostaInt:"+e.getMessage());
		}
	return c;
}//endattendiRisposta  


 
  public void chiudi() throws Exception {
	out.close();
  	in.close();
 	msgSocket.close();
	System.out.println("chiusa socket.");
	}
}//endconnettiTCP
