package Dns;
//specializzazione della classe DNSName
//per modellare il nome di un Auth. Server
import javax.naming.InvalidNameException;

public class ASName extends DNSName{

	public ASName(Domain domain) throws InvalidNameException{
		super(new ASType(),domain);
	}//costruttore
	 
	public ASName(NameParser np) throws InvalidNameException{
		super(new ASType(),np.getDomain());
	}//costruttore
	
	public ASName(String s) throws InvalidNameException{
		super(new ASType(),new Domain(s));
	}//costruttore
	
}//class ASName
