package Dns.Msg;

import java.io.*;
import Dns.DNSName;

public class BindNotFoundMsg extends AnswerMsg {	
	//Nome richiesto:
	//necessario per verificare che non ci sia stata 
	//sostituzione del messaggio di richiesta
	protected transient DNSName req;
	
	public BindNotFoundMsg(DNSName req,int timestamp){
		this.req=req;
		this.timestamp=timestamp;
	}//costruttore
	
	//serializzazione dell'oggetto////////////////////////////
	protected BindNotFoundMsg(){
		req=null;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(req);
		
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		req=(DNSName)in.readObject();
	}
	////////////////////////////////////////////////////////

	
	public String toString(){
		return "Nome "+ req+" non trovato";
	}//toString
	
}//class BindNotFoundMsg
