package AS.Cliente;


import java.io.*;
import java.net.*;
//import java.util.Hashtable;
import java.util.*;
import AS.Util.*; //indirizzo; costanti;
import Msg.PacketMsg;
import Security.RSACipher;
import iaik.security.rsa.*;
import java.security.*;
import com.entrust.util.*;
import AS.BtoA;
import AS.Msg.*;
import Security.chiave;
import Dns.Msg.*;
import Dns.*;
import AS.Cliente.Gui.*;
import Exceptions.*;

public class Client {
	//timeout richieste in sec;
	public final static int timeOut=20;
	//int timestamp = 0;
	chiave KeyA=null;
	chiave KeyS=null;
	int hostPort;
	String identita;
//	ArrayList adrGestore;
	int resolverPort;			   //per prove locali
	//costruttore per la porta di ascolto
	public  Client(int hostPort,String identita,int resolverPort) 	{
		this.hostPort = hostPort;
		this.identita=identita;
		this.resolverPort=resolverPort;
		try{
	      costanti c =new costanti(); 
			//REPERIMENTO DELLE CHIAVI DEL CLIENT
			KeyA=new chiave(c.getKPr(identita),c.getKPb(identita));
			// E DEL SERVER
			KeyS=new chiave(c.getKPbServer());

/*			if ((adrGestore=trovaGestore())==null) {
						System.out.println("impossibile trovare Gestore ");
						System.exit(1);
						}  */

		}
		catch( Exception e){
			System.out.println("Errore reperimento chiavi.. file chiavi inesistente  :"+e.getMessage()); 
			System.exit(1);}   
		} //endClient
	
	/*	//costruttore per le comunicazioni tra Client
		public  Client(String identita,int resolverPort) 	{
		this.identita=identita;
		this.resolverPort=resolverPort;
		try{
		   costanti c =new costanti(); 
			//REPERIMENTO DELLE CHIAVI DEL CLIENT
			KeyA=new chiave(c.getKPr(identita),c.getKPb(identita));
			// E DEL SERVER
			KeyS=new chiave(c.getKPbServer());
			
			if ((adrGestore=trovagestore())==null) {
						System.out.println("impossibile trovare Gestore ");
						System.exit(1);
						}
			
			}
			catch( Exception e){
				System.out.println("Errore reperimento chiavi Server :"+e.getMessage()); 
				System.exit(1);}   
		} //endClient
		*/




 public int Rtimestamp(){
	 Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
 	int timestamp = Math.abs(nran.nextInt())%10000;
 	return timestamp;
 }//endRtimestamp	 

	 
 public  BtoA parti(String nameB)  {
	connettiTCP conn=null;
			try{	
				
				//String nameB=richiestaNome(); //LEGGO DA INPUT IL CLIENT (NOME LOGICO) DA RICERCARE
				
				System.out.println("richiedo chiave pubblica di  "+nameB+" a Gestore ");

				Object obj = parla(nameB);	   //MSG DI RICHIESTA AL GESTORE!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		
				if (obj instanceof String) {  //System.out.println("Ho ricevuto una stringa - Client parti");
					System.out.println("ricevuto risposta: "+(String)obj);
					return null;
				}
				if (obj instanceof RSAPublicKey) {
						System.out.println("Ho ricevuto una chiave - Client parti");
						RSAPublicKey keyB = (RSAPublicKey)obj;
						nonce n = new nonce();
						int tmp=Rtimestamp();
						nonce nc = n.preparanonce(keyB,identita,tmp);
						//nonce nc = n.preparanonce(keyB,"stefano",tmp);    //invio nonce codificato con la chiave pubblica di B
																							 //N.B:il nome logico serve a B per reperire la chiave 
																							 //pubblica di A 
						
						/*
						//reperimento indirizzo CLIENT B											   ////////////AAAAAARGHHHHHHH
						InetAddress hostAddress = InetAddress.getByName("localhost");	   ///////////////////////////
						indirizzo adr =new indirizzo(hostAddress,3001);						   ///////////////////////////
						System.out.println("invio msg a client B localhost 3001");		   ///////////////////////////
						/////////////////////////////////////////////////////////////////////////////////////////////
						*/
						
						//reperimento indirizzo CLIENT B:
						indirizzo adr=null;
						try{
							Util.initCiphers();
							InetAddress local=InetAddress.getLocalHost();
							int t=Rtimestamp();
							DNSName qry=new DNSName(nameB);
							NameQueryMsg query=new NameQueryMsg(qry,true,t);
							DatagramPacket packet=query.writeToPacket(local,resolverPort);
							DatagramSocket socket=new DatagramSocket();
							socket.send(packet);
							packet=new DatagramPacket(new byte[1024],1024);
							socket.setSoTimeout(timeOut*1000);
							socket.receive(packet);
							socket.close();
							PacketMsg msg=SignedMsg.readFromPacket(packet);
							System.out.println("ricevuto:"+msg);
							if(((TimestampedMsg)msg).getTimestamp()!=t){
								System.out.println("Errore timestamp non corretto");
								return null;
							}
							if(msg instanceof BindFoundMsg){
								if(!(((BindFoundMsg)msg).getName().equals(qry))){
									System.out.println("Errore nome ricevuto non corretto");
									return null;
								}	
								adr=new indirizzo((((BindFoundMsg)msg).getValue())[0].getAddress(),(((BindFoundMsg)msg).getValue())[0].getPort());
							}else{
								System.out.println("Utente non trovato!");
								return null;
							}
						}catch(Exception e){
							System.out.println(e);
							return null;
						}
						
						
						
						
						//////////////////////////////////

						try{
							conn = new connettiTCP(adr);
							}
						catch(SocketException e){
							System.out.println("chiusa socket");
							return null;	
						}
						if (conn!=null){						 //PERCHE (!CONN.EQUALS(NULL)) NON VA???????????????
							System.out.print("preparato nonce ");  
							conn.inviaMsg(nc);							  							//INVIA NONCE
	
						 	System.out.println("ora aspetto");
							
							Object nric = (Object)conn.attendiRisposta();   				//RICEVO NONCERITORNO
							System.out.print("ricevuto nonceritorno ");
							if (nric instanceof nonceritorno){
								nonceritorno nr =(nonceritorno) nric;
								nonce nonceA=nr.getnonceA();
								nonce nonceB=nr.getnonceB();
												//controllo autenticit msg
		
								boolean ok=n.verificanonce(KeyA.getPrivate(),nonceA,tmp);  
								//B ha risposto con un nonceritorno codificato con la chiave pubblica di A
								System.out.print("ok?  "+ok);
 		   		
								if (ok) {
									System.out.println("  nonce correct!");
									//System.out.println("ricevuto timestamp di controllo"+(nonceA.gettimestamp()).toString());
									//invio il nonce B codificato con chiave pubblica di B
			
									//devo decifrare il nonce di B con la chiave privata di A e rispedirlo 
									//codificato con la chiave pubblica di B
									RSACipher cipher = new RSACipher();
									byte [] msginchiaro = cipher.decrypt(KeyA.getPrivate(),nonceB.gettimestamp());
								
									ByteArrayInputStream bais=new ByteArrayInputStream(msginchiaro);
									ObjectInputStream oin = new ObjectInputStream(bais);
									tistamp itr =(tistamp)oin.readObject();	
									int ts = itr.getN();
				
									nonce replynonce = n.preparanonce(keyB,nonceB.getname(),ts);
									System.out.print("preparato nonce di conferma  ");
									conn.inviaMsg(replynonce);													   //INVIA NONCECONFERMA
									System.out.println("sono pronto a comunicare con altro client....");
									//a questo punto se invio un msg all'altro client e la socket  chiusa vuol dire che 
									//l'ultimo mio timestamp  stato considerato non correct e devo riinoltrare la richiesta 
									
									///////////////////////////////////////////////////////////////////////////////////////
									BtoA btoa=new BtoA(conn,KeyA.getPrivate(),keyB);	  //mia chiave provata e sua chiave pubblica
    								//btoa.trasmetti();
	  								//for (int x=0; x<30000;x++) {int j=0; do{j++;}while(j<30000); }	//ATTESA  
									return btoa;
									///////////////////////////////////////////////////////////////////////////////////////
								} //endif
								else {System.out.println("  nonce not correct!");
										conn.chiudi();
								}//endelse
							}//endif
							if  (nric instanceof nonceerr) {
								 System.out.println("c'e' un intruso esco!!");
								 conn.chiudi();
							} 
							//LA DECISIONE DI CHIUDERE BRUSCAMENTE LA SOCKET NEL CASO DI RICEVIMENTO DI UN NONCE ERR O NOT CORRECT
							//DERIVA DAL FATTO DELLA NON SICUREZZA SUL MESSAGGIO E DELLA INCERTEZZA RIGUARDO ALL'IDENTITA' DELLA
							//PERSONA CON CUI STO PARLANDO. SI E' PREFERITO QUINDI CHIUDERE LA COMUNICAZIONE IN MODO TALE CHE IL
							//CLIENT POSSA RIINOLTRARE LA DOMANDA SENZA POSSIBILI NUOVE INTROMISSIONI
						}//end if (!conn=null)	  
				} 
				return null;
			}//endtry
			catch (SocketException se) {
        		System.out.println("chiusa Socket POSSIBILI INTROMISSIONI esco. "); // + se);
        	}
 			catch (EOFException se) {
        		System.out.println("chiusa Socket POSSIBILI INTROMISSIONI esco.. "); // + se);
	
					}
			
			catch (IOException ioe) {
        		System.out.println("Error in Client io: " + ioe);
		  			System.exit(1);
        	}
			catch (Exception e) {
        		System.out.println("Error in Client: " + e);
        		System.exit(1);
		  	}
			return null;
	}//parti
	
	
	
 
///////
	 public String richiestaNome()throws Exception{
	 	char c;				 					////////////////leggo da input il nome da ricercare
		StringBuffer s = new StringBuffer();
		System.out.println("aspetto il nome.........");
      Reader in = new InputStreamReader(System.in);
		while ((c = (char)in.read()) != '\n'){
				s.append(c);
				}
		String nam = new String(s);
		String nameB =nam.trim();
		//System.out.println("letto stringa "+nameB+" lunga "+nameB.length());
		return nameB;
		
	 
	 
	 }//endrichiestaNome



 
 public  Object parla(String name)
    {
    // Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
	 // timestamp = Math.abs(nran.nextInt())%10000;
	 int timestamp=Rtimestamp(); 
	 Object fine = null;


	 try {	
		// Apre una connessione Socket Client TCP							   /////////////////////////////////////////////////////
      
			//InetAddress hostAddress = InetAddress.getByName("localhost");  /////////////////////////////////////////////////////
		//indirizzo adr =new indirizzo(hostAddress,2001);				   	/////////////INDIRIZZO GESTORE (NOTO) !!!!!!!!!!!!!!!!
		//connettiTCP conn =new connettiTCP(adr);								/////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////7
				/*	indirizzo adr;
						try{
							Util.initCiphers();
							InetAddress local=InetAddress.getLocalHost();
							int t=Rtimestamp();
							//richiesta dominio
							Domain dom;
							DomainQueryMsg query=new DomainQueryMsg(t);
							DatagramPacket packet=query.writeToPacket(local,6060);
							DatagramSocket socket=new DatagramSocket();
							socket.send(packet);
							packet=new DatagramPacket(new byte[1024],1024);
							socket.setSoTimeout(20000);
							socket.receive(packet);
							socket.close();
							PacketMsg msg=SignedMsg.readFromPacket(packet);
							System.out.println("ricevuto:"+msg);
							if(((TimestampedMsg)msg).getTimestamp()!=t){
								System.out.println("Errore timestamp non corretto");
								return null;
							}
							if(msg instanceof DomainAnswerMsg){
								dom=((DomainAnswerMsg)msg).getDomain();
							}else{
								System.out.println("Utente non trovato!");
								return null;
							}
							//richiesta gestore:
							NameQueryMsg querym=new NameQueryMsg(new ASName(dom),true,t);
							packet=querym.writeToPacket(local,6060);
							socket=new DatagramSocket();
							socket.send(packet);
							packet=new DatagramPacket(new byte[1024],1024);
							socket.setSoTimeout(20000);
							socket.receive(packet);
							socket.close();
							msg=SignedMsg.readFromPacket(packet);
							System.out.println("ricevuto:"+msg);
							if(((TimestampedMsg)msg).getTimestamp()!=t){
								System.out.println("Errore timestamp non corretto");
								return null;
							}
							if(msg instanceof BindFoundMsg){
								adr=new indirizzo((((BindFoundMsg)msg).getValue())[0].getAddress(),(((BindFoundMsg)msg).getValue())[0].getPort());
							}else{
								System.out.println("Gestore non trovato!");
								return null;
							}
						}catch(Exception e){
							System.out.println(e);
							return null;
						}*/
 	   ArrayList adrGestore=new ArrayList();
		if ((adrGestore=trovaGestore(name))==null) {
			System.out.println("impossibile trovare Gestore ");
			return "Impossibile trovare Gestore ";
		}  
		int i=0;
		 boolean notesc=false;
		 connettiTCP conn=null;
		 int len =adrGestore.size(); 
		 do{
		   notesc=false;
			try{
			conn =new connettiTCP((indirizzo)adrGestore.get(i));	
			i++;
			if (i>len) throw new ComunicationException();
			}
			catch (ComunicationException e) {
            throw e;}
			catch (Exception e) {
            System.out.println("impossibile creare socket : ");
				notesc=true;}
		 }while (notesc);
		///////////////////////////////////////////////
      requestMsg req =new requestMsg(name,timestamp);	 //msg e timestamp
		
		conn.inviaMsg(req);  										 //INVIA MSG RICHIESTA A GESTORE
		
	  	firma risp=(firma)conn.attendiRisposta();			    //RICEVO MSG RISPOSTA DA GESTORE
		//controlla(risp);
		conn.chiudi();
		
		System.out.print("tutto ok ricevuto oggetto      ");
		
		if (risp instanceof answerKey) {
								answerKey r=(answerKey)risp;		   
								byte[] sign =r.getsign();
								boolean ok=r.verifica(sign,KeyS.getPublic()); 
								System.out.println("verifico validita' ?  "+ok);
								if (ok){//System.out.println("tutto ok   ");
								        answerMsg ansMsg=(answerMsg)r.getObj();
										  if(ansMsg.getN()==timestamp)  {
										  		fine =(RSAPublicKey) ansMsg.getKey();
										  		System.out.println("chiave   "+ansMsg.getKey());
												}
										  else {//System.out.println("msg inconsistente");
										        fine ="msg risposta modificato 1";}
										  }
								else {//System.out.println("msg risposta modificato 1");
									      fine ="msg risposta modificato 11";}
								}
								
							

		 if (risp instanceof notFindKey){
		 						notFindKey r=(notFindKey)risp;		   
								byte[] sign =r.getsign();
								boolean ok=r.verifica(sign,KeyS.getPublic()); 
								System.out.println("verifico validita' ?  "+ok);
								if (ok){
								        notFindMsg nfMsg=(notFindMsg)r.getObj();
										  if(nfMsg.getN()==timestamp)  {//System.out.println("nessuna corrispondenza trovata 2");
										                                fine ="nessuna corrispondenza trovata 2"; }
										  else {//System.out.println("msg risposta modificato 2");
										         fine ="msg risposta modificato 2";}
										  }
								else {//System.out.println("msg risposta modificato");
								      fine ="msg risposta modificato 22";}
								}
								
		 
		 if (risp instanceof notCopiaKey) {
		 					  notCopiaKey r=(notCopiaKey)risp;		   
								byte[] sign =r.getsign();
								boolean ok=r.verifica(sign,KeyS.getPublic()); 
								System.out.println("verifico validita' ?  "+ok);
								if (ok){
								        notCopiaMsg ncMsg=(notCopiaMsg)r.getObj();
										  if(ncMsg.getN()==timestamp)  {//System.out.println("Nessuna Copia disponibile  3 ");
										                                fine ="Nessuna Copia disponibile   3 ";}
										  else {//System.out.println("msg risposta modificato 3");
										        fine ="msg risposta modificato 3";}
										  }
								else {//System.out.println("msg risposta modificato");
								      fine ="msg risposta modificato 33";}
								}
								
		 
	}//endtry
	catch (ComunicationException e) {
            System.out.println("impossibile trovare Gestore: nessuno attivo " );}
   catch (UnknownHostException uhe)  {
            System.out.println("UnknownHostException: " + uhe);
        }
	catch (EOFException se) {
        		System.out.println("chiusa Socket POSSIBILI problemi Gestore esco: "); // + se);	   //$
        	}
   catch (Exception ioe)  {
            System.err.println("Errore in : " + ioe);
        }
	
   //System.out.println("  - fine parla - ");   
   System.out.println("  - ---------- - ");       
   return fine;
   }//endparla

	protected ArrayList trovaGestore(String nome){
	ArrayList adr =new ArrayList();
		try{
			Util.initCiphers();
			InetAddress local=InetAddress.getLocalHost();
			int t=Rtimestamp();
			/*
			//richiesta dominio
			Domain dom;
			DomainQueryMsg query=new DomainQueryMsg(t);
			DatagramPacket packet=query.writeToPacket(local,resolverPort);
			DatagramSocket socket=new DatagramSocket();
			socket.send(packet);
			packet=new DatagramPacket(new byte[1024],1024);
			socket.setSoTimeout(20000);
			socket.receive(packet);
			socket.close();
			PacketMsg msg=SignedMsg.readFromPacket(packet);
			System.out.println("ricevuto:"+msg);
			if(((TimestampedMsg)msg).getTimestamp()!=t){
					System.out.println("Errore timestamp non corretto");
					return null;
				}
			if(msg instanceof DomainAnswerMsg){
					dom=((DomainAnswerMsg)msg).getDomain();
			}else{
				System.out.println("Utente non trovato!");
				return null;
			}
			*/
			//richiesta gestore:
			Parser p=new Parser(nome);
			NameQueryMsg querym=new NameQueryMsg(new ASName(p.getDomain()),true,t);
			DatagramSocket socket=new DatagramSocket();
			DatagramPacket packet=querym.writeToPacket(local,resolverPort);
			socket=new DatagramSocket();
			socket.send(packet);
			packet=new DatagramPacket(new byte[1024],1024);
			socket.setSoTimeout(timeOut*1000);
			socket.receive(packet);
			socket.close();
			PacketMsg msg=SignedMsg.readFromPacket(packet);
			System.out.println("ricevuto:"+msg);
			if(((TimestampedMsg)msg).getTimestamp()!=t){
			System.out.println("Errore timestamp non corretto");
			return null;
			}
			if(msg instanceof BindFoundMsg){
					int len=(((BindFoundMsg)msg).getValue()).length;
					for(int i=0; i<len;i++){
						indirizzo address=new indirizzo((((BindFoundMsg)msg).getValue())[i].getAddress(),(((BindFoundMsg)msg).getValue())[i].getPort());
						adr.add(address);
					}
					}else{
					System.out.println("Gestore non trovato!");
					return null;
			}
			}catch(javax.naming.InvalidNameException e){
				System.out.println("Nome utente non corretto.");
				return null;
			}catch(Exception e){
				System.out.println(e);
				return null;
			}
		return adr;
	
	
	}
 
  public static void main(String args[])  {
	Client Cio=null;
	int hPort=0;
	int rPort;
		//controllo che ci sia un argomento...
		if(args.length!=3){
			System.err.println("usage: java Client port_number identita' port_resolver\n"); //la porta riguarda la connessione TCP di ascolto
			System.exit(1);
		}
		try	{
		
		hPort = (Integer.parseInt(args[0]));
		rPort = (Integer.parseInt(args[2]));
		
			//hostPort = (Integer.valueOf(args[0])).intValue();
			Cio= new Client(hPort,args[1],rPort);
			
		}
		catch(NumberFormatException e)  {
			System.out.println("port_number must be an integer\n");
			System.exit(1);
		}

		if(!Cio.equals(null)) {clientListen cL= new clientListen(hPort,Cio);
									  cL.start();
									  }
		System.out.println("in ascolto su "+hPort);
		//Cio.parti(hostPort);
		ClientGui frame=new ClientGui(Cio,args[1]);
		frame.show();
		}//endmain

}//endClient

 
