package AS;


/* I passi svolti da una copia sono: 
 * -legarsi ad una determinata porta di lavoro 
 * -richieere al Gestore la tabella hash su cui lavorare
 * -mettersi in ascolto sulla porta per rispondere alle query.
 * Nota:  inutile creare un thread che gestisca il passaggio  
 * della tabella poich la copia per poter rispondere ha
 * bisogno della tabella!!!
 * Notare che la tabella hash viene passata con il protocollo
 * TCP entry per entry codificate e numerate per garantire la 
 * consistenza della tabella stessa. La risposta le query
 * viene effettuata con UDP. Si sono considerati quindi tutti
 * i possibili casi di messaggi di errore o di riemissione 
 * per timeout
 */


import java.io.*;
import java.net.*;
import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import com.entrust.util.*;
import Msg.PacketMsg;		  //notFindMsg    requestMsg   answerMsg
import AS.Cliente.cli;
import AS.Util.*;
import AS.Msg.*;
import Security.chiave;
import Dns.Msg.*;
import Dns.*;

public class Copia{
		//timeout richieste in secondi:
		public static final int timeOut=20;
		DatagramSocket DatagramSvt = null; 
    	DatagramPacket recvPacket, sendPacket;
    	int hostPort;		
		int resolverPort;
    	Hashtable ht =null;
		Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
		private int timestampc = Math.abs(nran.nextInt())%10000; //random();
		private chiave keyS = null;

public  void inctimestamp(){
		timestampc++;}
public synchronized int gettimestamp(){
		int p =timestampc;
		inctimestamp();
		return p;}
		
public int Rtimestamp(){
	 Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
 	int timestamp = Math.abs(nran.nextInt())%10000;
 	return timestamp;
 }//endRtimestamp	 

		
		
		public  Copia(int resolverPort)
		{  this.resolverPort = resolverPort;
			try {hostPort=legatiaporta();}

					//System.out.println("porta numero "+hostPort+" effettuata connessione ");}
			catch (SocketException se){System.out.println("Porta occupata  :"+se); }
			catch (IOException ioe) {System.out.println("Error in Copia: " + ioe);}
			catch (NumberFormatException nfe) {System.err.println("port_number must be an integer\n: " + nfe);}
			catch (Exception e) {System.out.println("Error in Copia: " + e);}
		}
		/*
		public  Copia(indirizzo adr)
		{  
			try {
				hostPort=legatiaporta();
				System.out.println("aggiorno richiedo a Gestore ");
				do{} 
				while(aggiorna(adr));
				System.out.println("Inizioalavorare");
				IniziaALavorare();
			
			 }
			catch (SocketException se){System.out.println("Porta occupata  :"+se); }
			catch (IOException ioe) {System.out.println("Error in Copia: " + ioe);}
			catch (NumberFormatException nfe) {System.err.println("port_number must be an integer\n: " + nfe);}
			catch (Exception e) {System.out.println("Error in Copia: " + e);}
			
			}
		*/

	public int legatiaporta() throws Exception {
			DatagramSvt = new DatagramSocket();
   		System.out.println("porta numero "+DatagramSvt.getLocalPort()+" effettuata connessione ");
			return DatagramSvt.getLocalPort();
			}//endlegatiaporta

public boolean aggiorna(indirizzo adr)throws Exception {
	//il parametro  indirizzo del Gestore che deve fornirci la tabella hash
	
	
	/* PROTOCOLLO:
	 					 *                Gestore (Sht)                           Copia (cli)    
						 *                              dim   ====> 1 >>>>
						 *                            entry42 ====> 1 >>>>
						 *                            entry43 ====> 1 >>>>
						 *                              ...
						 *                            entry49 ====> 1 >>>>
						 *                            entry50 ====> 1 >>>>
						 *                                     << 2 <<<====    dim
						 *             
					    *
	 					 * 
						 *  Qualsiasi evento che causa un anomalia  causa il rinvio TOTALE della tabella
	 					 */
	
	 //REPERIMENTO DELLE CHIAVI DEL SERVER
	costanti cns = new costanti();
	
	keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
	
	boolean notTuttoOK=false;
	//Avvio connessione con Gestore per reperimento tabella
	connettiTCP conn = new connettiTCP(adr);
	InetAddress hostAddress = InetAddress.getLocalHost();
	Object copiaadr = new indirizzo(hostAddress,hostPort);
	 
	conn.inviaMsg(copiaadr);   //!!!!!!!!!!!!!indirizzo copia inviato al gestore per conoscenza
	int k=0;
	do{ k++;
	  notTuttoOK=false; 
	  System.out.println(" richiedo la tabella Hash ");
	  cli c=new cli(conn,keyS.getPrivate(),keyS.getPublic());
     ht=(Hashtable)c.RxService(); 
	  // l' hashtable vuoto  il modo per indicare che c'e' qualcosa che non va
	  if (ht.isEmpty()) {System.out.println(" hashtable vuoto"); notTuttoOK=true;}  
	  else System.out.println(" tutto ok ");
	  //for (int x=0; x<1000;x++) {int j=0; do{j++;}while(j<30000); }      //ATTESA????
	}while((notTuttoOK) && (k<5)); 
	//nel caso ci siano dei problemi che non  siano la chiusura della socket dalla
	//parte del Gestore (il che significherebbe che il Gestore non possiede una 
	//tabella hash consistente e questo caso viene rilevato tramite eccezioni),
	// ad esempio manipolazioni o intromissioni di terzi viene riinoltrata la richiesta 
	//5 volte oltre le quali si  pensato di uscire ==> canale attualmente non sicuro

	conn.chiudi();  
	System.out.println(" lista ");
	
	for (Enumeration e = ht.keys() ; e.hasMoreElements() ;) {
              //String name=(String)e.nextElement();
				  //RSAPublicKey pkb = (RSAPublicKey)ht.get(name);
				  System.out.print(e.nextElement()+"  ");
				  }
	System.out.println(" ");



	return (!notTuttoOK);
}//endaggiorna	

///////////////7

public void aggiornaaltri(ArrayList adrG)throws Exception {
	//il parametro sono gli indirizzi del Gestori
	
	
	int sz =adrG.size();

	for (int i=0;i<sz;i++){
	   try{
			//boolean notTuttoOK=false;
			System.out.println("aggiorno gestore: "+((indirizzo)adrG.get(i)).getadr()+"  "+((indirizzo)adrG.get(i)).getport());
			//Avvio connessione con Gestore per reperimento tabella
			connettiTCP conn = new connettiTCP((indirizzo)adrG.get(i));
			InetAddress hostAddress = InetAddress.getLocalHost();
			Object copiaadr = new cindirizzo(hostAddress,hostPort);
	 
			conn.inviaMsg(copiaadr);   //!!!!!!!!!!!!!indirizzo copia inviato al gestore per conoscenza
	
			conn.chiudi();  
			System.out.println("    aggiornamento riuscito! ");
		}
		catch (SocketException e) {System.out.println("impossibile recapitare msg ");}
		catch (EOFException e) {System.out.println("impossibile recapitare msg ");}		  //$
		//catch (UnknownHostException e) {System.out.println("Host inesistente! Riprovare ");}
		catch (Exception e) {System.out.println("Error in Copia: aggiornaaltri " + e);}
		//return (!notTuttoOK);
	 }
}//endaggiorna	

 ////////////////
public void IniziaALavorare()
{ 

	try
     	{ while (true){
				recvPacket= new DatagramPacket(new byte[512], 512);
				sendPacket= new DatagramPacket(new byte[1024],1024);		  //
				
				/* i msg di inoltro richiesta in cui viaggia una chiave devono per forza essere di
				 * 1024. infatti
				 *
				 * 		requestMsg    >>>>>    120 byte
				 * 		answerMsg     >>>>>    726 byte
				 * 		notFindMsg    >>>>>     84 byte
				 */




				DatagramSvt.receive(recvPacket);
				System.out.println("arrivato pacchetto a copia ");  //lungo  "+recvPacket.getLength());
				//TRASFORMO IL PACCHETTO IN MSG
				requestKey richiesta =(requestKey)msgUDP.readFromPacket(recvPacket);
				
				//controllo
				requestMsg rMsg=(requestMsg) richiesta.getObj(); 
				byte[] signature =richiesta.getsign();
				boolean ok=richiesta.verifica(signature,keyS.getPublic());
				//System.out.println("fino qui        "+ok); 
				if (ok){

						//Ricerco in nome nella tabella
						RSAPublicKey pub_key=(RSAPublicKey)ht.get(rMsg.getName());
						//System.out.println("   pacchetto    "+pub_key);
				
						if (pub_key==null){ //entry assente                                //pub_key.equals(null) non va
								//RIinvio lo stesso timestamp che ho ricevuto==>>>>>>>richiesta.getN()
								System.out.println("nessuna corrispondenza! nome inesistente.  ");
								notFindMsg risposta = new notFindMsg(rMsg.getN());
								msgFirma firma=new msgFirma(risposta);
								byte[] sign = firma.autentica(keyS.getPrivate());  
								notFindKey req = new notFindKey(risposta,sign);
								sendPacket = req.writeToPacket(recvPacket.getAddress(), recvPacket.getPort());
								DatagramSvt.send( sendPacket );
							} //endif
						else {/*entry presente	*/ 
								answerMsg risposta =new answerMsg(pub_key,rMsg.getN());
								//RIinvio lo stesso timestamp che ho ricevuto==>>>>>>>richiesta.getN()
								msgFirma firma=new msgFirma(risposta);
								byte[] sign = firma.autentica(keyS.getPrivate());  
								answerKey req = new answerKey(risposta,sign);
								sendPacket = req.writeToPacket(recvPacket.getAddress(), recvPacket.getPort());
								DatagramSvt.send( sendPacket );
							} //endelse
						System.out.println("  inviato pacchetto ");  //+ sendPacket.getLength());
						 }//endif - ok
						 else  { //arrivato pacchetto non consistente
						 		refuseMsg risposta = new refuseMsg(rMsg.getN());
								msgFirma firma=new msgFirma(risposta);
								byte[] sign = firma.autentica(keyS.getPrivate());  
								refuseKey ref = new refuseKey(risposta,sign);
								sendPacket = ref.writeToPacket(recvPacket.getAddress(), recvPacket.getPort());
								DatagramSvt.send( sendPacket );
						 	    }
        } //endwhile
  }//endtry
	catch (SocketException se) {
        System.out.println("Error in Copia: " + se);
        }
  catch (IOException ioe) {
        System.out.println("Error in Copia: " + ioe);
        }
catch (Exception e) {
        System.out.println("Error in Copia: " + e);
        }
}//endIniziaALavorare

	

	protected ArrayList trovaG(){
	ArrayList adr = new ArrayList();
		try{
			Util.initCiphers();
			InetAddress local=InetAddress.getLocalHost();
			int t=Rtimestamp();
			//richiesta dominio
			Domain dom;
			DomainQueryMsg query=new DomainQueryMsg(t);
			DatagramPacket packet=query.writeToPacket(local,resolverPort);
			DatagramSocket socket=new DatagramSocket();
			socket.send(packet);
			packet=new DatagramPacket(new byte[1024],1024);
			socket.setSoTimeout(timeOut*1000);
			socket.receive(packet);
			socket.close();
			PacketMsg msg=SignedMsg.readFromPacket(packet);
			System.out.println("ricevuto:"+msg);
			if(((TimestampedMsg)msg).getTimestamp()!=t){
					System.out.println("Errore timestamp non corretto");
					return null;
				}
			if(msg instanceof DomainAnswerMsg){
					dom=((DomainAnswerMsg)msg).getDomain();
			}else{
				System.out.println("Utente non trovato!");
				return null;
			}
			//richiesta gestore:
			DNSName qry=new ASName(dom);
			NameQueryMsg querym=new NameQueryMsg(qry,true,t);
			packet=querym.writeToPacket(local,resolverPort);
			socket=new DatagramSocket();
			socket.send(packet);
			packet=new DatagramPacket(new byte[1024],1024);
			socket.setSoTimeout(timeOut*1000);
			socket.receive(packet);
			socket.close();
			msg=SignedMsg.readFromPacket(packet);
			System.out.println("ricevuto:"+msg);
			if(((TimestampedMsg)msg).getTimestamp()!=t){
				System.out.println("Errore timestamp non corretto");
				return null;
			}
			if(msg instanceof BindFoundMsg){
					if(!(((BindFoundMsg)msg).getName().equals(qry))){
						System.out.println("Errore nome ricevuto non corretto");
						return null;
					}
					int len=(((BindFoundMsg)msg).getValue()).length;
					//System.out.println(" qua "+len);
					int i=0;
					System.out.println(" ricevuti "+len+" indirizzi Gestori");
					for(i=0; i<len;i++){
					   //System.out.println(" provo con "+i);
						indirizzo address=new indirizzo((((BindFoundMsg)msg).getValue())[i].getAddress(),(((BindFoundMsg)msg).getValue())[i].getPort());
						//System.out.println(" provo con "+i);
						adr.add(address);
					}
					}else{
					System.out.println("Gestore non trovato!");
					return null;
			}
			}catch(Exception e){
				System.out.println(e);
				return null;
			}
		return adr;
	
	
	}

 




public static void main(String[] args){
		Copia DtgServer = null;
		ArrayList adrGestore=null;
 	   if ( args.length !=1 ){
 		System.err.println("usage: java Copia   resolverPort\n");
      System.exit(1);
		}
		try{
			int rPort = Integer.valueOf(args[0]).intValue();			//porta del resolver;
			//InetAddress hostAddressG = InetAddress.getByName(args[0]);
		
			DtgServer=new Copia(rPort);
   
			if (!DtgServer.equals(null)) {												//INDIRIZZO GESTORE 
				//InetAddress hostAddress = InetAddress.getByName("localhost");
				//indirizzo adr =new indirizzo(hostAddressG,hostPortG);
				//System.out.println("aggiorno richiedo a Gestore  "+hostAddressG+"   "+hostPortG);
				if ((adrGestore=DtgServer.trovaG())==null) {
						System.out.println("impossibile trovare Gestore ");
						System.exit(1);
						}
				
				
				//il metodo aggiorna effettua 5 tentativi. se nessuno di questi va a 
				//buon fine esce restituendo false.
				boolean notok=false;
				int p=0;
				do{
				boolean aggiornato = DtgServer.aggiorna((indirizzo)adrGestore.get(p));
				if (!aggiornato) {System.out.println("impossibile aggiornamento riprovare ..."); 
										p++; 
										notok=true;}
				else {DtgServer.aggiornaaltri(adrGestore);
						System.out.println("Inizioalavorare");
						}
				}while(notok);
				DtgServer.IniziaALavorare();
			}

		}//endtry
		catch (SocketException e) {System.out.println("nessuna risposta da gestore! Riprovare ");}
		catch (EOFException e) {System.out.println("nessuna risposta da gestore! Riprovare ");}		  //$
		//catch (UnknownHostException e) {System.out.println("Host inesistente! Riprovare ");}
		catch (Exception e) {System.out.println("Error in Copia: " + e);}

} //endmain






 
}//endCopia
