package AS;


/*
 * Gestore si mette in ascolto su una det 'porta in attesa di connessione. per gestire
 * la comunicazione crea un thread (GestoreThread). quest'ultimo verifica se si tratta
 * di un Client o di una Copia e agisce di conseguenza:
 * se client inoltra la richiesta ad una delle copie disponibili a fornire il servizio
 *  le richieste vengono inoltrate ciclicamente a tutte le copie 
 * se copia registra il suo indirizzo tra le copie disponibili a fornire il servizio e
 *  gli invia la tabella su cui lavorare.
 */

import java.net.*;
import java.io.*;
import java.util.ArrayList;
import com.entrust.util.*;
import iaik.security.rsa.*;
import java.security.*;
import Security.chiave;
import AS.Util.*;
import AS.Cliente.cliS;
import AS.Msg.*;

public class  GestoreS extends Gestore{
	//int hostPort;
	//ArrayList listaCopie = new ArrayList();
	//private int posizione = 0;				   //posizione all'interno dell'ArrayList della copia
	                                      //che deve fornire il servizio secondo l'ordine
	                                     //prestabilito (ciclico)
	//private int timestamp = 1;
	//chiave keyS;
  
	public  GestoreS (int hostPort,indirizzo adr) 	{
		super(hostPort);       //porta di ascolto del collegamento TCP
		////									  //adr  indirizzo Gestore primario a cui chiedere lista copie
		
		try{
			//REPERIMENTO DELLE CHIAVI DEL SERVER
			//costanti cns = new costanti();
			//keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
			int j=0;
			do{ j++;
			    System.out.println("tentativo di richiesta lista copie "+j);
				 if(j>5){ System.out.println("tentativo fallito ");
				 			 System.exit(1);}
		   }while(!richiestaCopie(adr));
			}
		catch( Exception e){
			System.out.println("Errore reperimento chiavi Server :"+e); 
			System.exit(1);}

		

	} //costruttore

public boolean richiestaCopie(indirizzo adr)throws Exception {
	//il parametro  indirizzo del Gestore primario a cui richiedere lista copie
	

	
	boolean notTuttoOK=false;
	//Avvio connessione con Gestore per reperimento lista copie
	connettiTCP conn = new connettiTCP(adr);
	//InetAddress hostAddress = InetAddress.getByName("localhost");
	Object reqAdr = new reqCopieMsg(45);
	 
	conn.inviaMsg(reqAdr);   
	int k=0;
	//do{
 k++;
	  notTuttoOK=false; 
	  System.out.println(" richiedo la lista delle copie ");
	  cliS c=new cliS(conn,keyS.getPrivate(),keyS.getPublic());
     listaCopie=(ArrayList)c.RxService(); 
	  // l' hashtable vuoto  il modo per indicare che c'e' qualcosa che non va
	  if (listaCopie.isEmpty()) {System.out.println(" lista vuota"); }  
	  else System.out.println(" tutto ok ");
	  //for (int x=0; x<1000;x++) {int j=0; do{j++;}while(j<30000); }      //ATTESA????
	//}while((notTuttoOK) && (k<5)); 
	//nel caso ci siano dei problemi viene riinoltrata la richiesta 
	//5 volte oltre le quali si  pensato di uscire ==> canale attualmente non sicuro

	conn.chiudi();  
	System.out.println(" lista "+!notTuttoOK);
	
	
	System.out.println(" ");



	return (!notTuttoOK);
}//endrichiestaCopie


	public static void main(String args[])  {
		GestoreS serverSocket=null;
		//controllo che ci sia un argomento...
		if(args.length!=3){
			System.err.println("usage: java Gestore port_number  ipGestorePrimario portGestorePrimario\n"); 
			//la porta riguarda la connessione TCP
			System.exit(1);
		}
		//System.out.println("qua");
                                       //...e che sia un intero
		try	{
			int hostPortG = Integer.valueOf(args[2]).intValue();
			InetAddress hostAddressG = InetAddress.getByName(args[1]);
			indirizzo adr =new indirizzo(hostAddressG,hostPortG);
			//System.out.println("qua");
			serverSocket= new GestoreS(Integer.parseInt(args[0]),adr);
			System.out.println("avvio ok");
		}
		catch(NumberFormatException e)  {
			System.out.println("port_number must be an integer\n");
			System.exit(1);
		}
    	 catch(Exception e)  {
			System.out.println("errore");
			System.exit(1);
		}
		//System.out.println("chiamo Comunica ");
		if(!serverSocket.equals(null)) serverSocket.Comunica();
	}//main()

}//endGestore




