package AS;



import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import Msg.PacketMsg;
import java.security.Signature;
import iaik.security.rsa.*;
//import iaik.security.rsa.RSASignature;
//import com.entrust.util.*;
import Security.chiave;
import AS.Util.*;
import Exceptions.*; //InexistanceFileException;
import AS.Msg.*;

class ShtS {						  //fz Server di aggiornamento e verifica consistenza hashtable
connettiTCP conn =null;		  //il primo passo  la lettura dell'Hashtable da file
transient Socket client;	  //viene inviato la dimensione della tabella da lleggere
RSAPrivateKey kPr;			  //ogni singola entry viene poi firmata e spedita
RSAPublicKey kPb;				  //infine si riceve l'ultimo timestamp letto dalla copia
ArrayList listaCopie;		  //(e quindi la dim dell'hashtable). qusto msg serve per 
									  //verificare che effettivamnete le entry della copia non 
									  //siano TUTTI msg vecchi intercettati e riutilizzati

	 
	  public ShtS(connettiTCP conn,ArrayList listaCopie,RSAPrivateKey kPr,RSAPublicKey kPb){
	 	this.conn=conn;
		this.listaCopie=listaCopie;
		this.kPr=kPr;
		this.kPb=kPb;
		
		}
   	
	 public static void main(String args[])
    {	  
        ServerSocket serverSocket = null;
        Socket clientSocket = null;
        RSAPrivateKey kPr1=null;
		  RSAPublicKey kPb1=null;
		  ArrayList lCopie = new ArrayList();
        try
        {
            // Create the server socket
            serverSocket = new ServerSocket(4000);		//crea un socket server e lo lega alla porta 2000  	 	
          	System.out.println("sono in attesa");
				clientSocket = serverSocket.accept();
				System.out.println("Effettuata accept");
            //Si genera quindi un nuovo socket usata per la comunicazione con il cliente
				//REPERIMENTO DELLE CHIAVI DEL SERVER
				costanti cns = new costanti();
				chiave keyS=new chiave(cns.getKPrServer(),cns.getKPbServer()); 
				
				
		 		kPr1=keyS.getPrivate();
 		   	kPb1=keyS.getPublic();

				connettiTCP conn1 = new connettiTCP(clientSocket);
				//ServiceCopia(clientSocket,kPr,kPb);
				/*
				int k=0;											    //senza questo codice il size  0
				do{
				k++;
				InetAddress hostAddress = InetAddress.getByName("localhost");
				indirizzo adr = new indirizzo(hostAddress,0);
				lCopie.add(adr);        
				}while(k<4);
				  */
				
				ShtS shts=new ShtS(conn1,lCopie,kPr1,kPb1);					//
				boolean vero=shts.ServiceCopia(); 					//
				//////////////////////////////////////////////////
				
				System.out.println("ricevuto    "+vero);
            serverSocket.close();
        }  //endtry
        catch (Exception ioe)  {
            System.out.println("Errore in Sht: " + ioe.getMessage());
        }
		  
    }//endmain
	 

    public  boolean ServiceCopia() throws Exception	//restituisce true se  andato tutto bene:   
    {boolean oK=true;											//il size di ritorno coincide e non si sono
	  
	  try{															//verificati msg di errore
		costanti cns = new costanti();
  
		
				int sz=0;
				int k=0;

				int tsg=Rtimestamp();
				//if (listaCopie.isEmpty()) {conn.inviaMsgInt(0);}
				//else {
				sz=listaCopie.size();	  
						conn.inviaMsgInt(sz);
				//      System.out.println("size "+sz);}
				if (sz==0) tsg=1;
				
				//System.out.println("sono qua ");
				for (int e = 0 ; e<sz;e++) {
            	 //System.out.println("sono qua 1 ");  
				 	 indirizzo adrc = (indirizzo)listaCopie.get(e);
					  System.out.println(" indirizzo      "+adrc.getadr()+"   "+adrc.getport());

					//System.out.println("entry");
						adrC r1a =new adrC(adrc,tsg++);
						msgFirma firma1=new msgFirma(r1a);
						byte[] sign1 = firma1.autentica(kPr);  
						adrKey reqa = new adrKey(r1a,sign1);
						//out.writeObject(reqa);
						conn.inviaMsg(reqa);
          	} //endfor;
				//System.out.println(" 2 "); 
				
				
				
				
				
				
				 //ora dopo l'invio delle entry attendo il ricevimento di un oggetto 
				 //indicativo del size dell' HT. ricevo l'ultimo timestamp che ho 
				 //inviato alla copia, INCREMENTATO
					System.out.println("attendo ");
				tstsign tst=(tstsign)conn.attendiRisposta();
				byte[] signaaa=tst.getsign();
				oK=tst.verifica(signaaa,kPb);
				//il campo oK qui mi indica se il messaggio  consistente ovvero
				//se non ha subito modifiche

				//eseguo quindi il controllo sul contenuto del msg  cio viene controllato che
				//l'ultimo timestamp letto dalla copia sia lo stesso inviato dal Gestore
				// un ulteriore prova di freschezza del msg
				System.out.println("ok?  "+oK);
				if (oK){ 
						//System.out.println("tsg "+tsg);
						  int tmpconferma=((tistamp)tst.getObj()).getN();
						  
						  System.out.println("  ricevuto  tmp conferma  "+tmpconferma+"  confronto "+(--tsg));
							//System.out.println("  ricevuto  tmp conferma  "+((tistamp)tst.getObj()).getN()+"  confronto "+());
						  //System.out.print("tsg?  "+tsg);
						  if (tst.getObj()instanceof tistamperr) oK=false; 
						  //if ( (!(tst.getObj() instanceof tistamp)) || (!(((tistamp)tst.getObj()).getN()==(tsg))) ) {
						  if ( (!(tst.getObj() instanceof tistamp)) || (!(tmpconferma==(tsg))) ) {
						  				oK=false; 
										System.out.println(" tmp conferma not correct!  ");}  //il msg non  fresh!!!!!!!!!!
				 }
				System.out.println("trasmissione lista copie oK?  "+oK);
					//do{}while(true);
	  
	  
					
	}//endtry

	catch( Exception e){
		//System.out.println("Errore :"+e.getMessage()); oK=false;
 	   throw e;
		} 
return oK; 
}


public int Rtimestamp(){
 Random nran=new Random(); //Generazione Random dello stato iniziale del timestamp interno della Copia
 int timestamp = Math.abs(nran.nextInt())%1000;
 return timestamp;
 }



 }
