package Dns;

import java.net.*;

//La classe CacheValue  l'estensione della classe 
//Value con l'aggiunta del TimeToLive
class CacheValue extends Value{
	protected int TTL;
	
	public int getTimeToLive(){
		return TTL;
	}//getTimeToLive
	
	public void setTimeToLive(int TTL){
		this.TTL=TTL;
	}//setTimeToLive
	
	public CacheValue(InetAddress addr,int TTL){
		super(addr);
		this.TTL=TTL;
	}//costruttore
	
	public CacheValue(InetAddress addr,int port,int TTL){
		super(addr,port);
		this.TTL=TTL;
	}//costruttore
	
	public CacheValue(Value val,int TTL){
		this(val.getAddress(),val.getPort(),TTL);
	}//costruttore 
	
	public String toString(){
		return super.toString()+"("+TTL+")";
	}
	
}//CacheValue
