package Dns.Gui;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import Dns.*;

public class PrimaryInitGui extends Thread implements WindowListener,ActionListener,ItemListener{
	File file;
	boolean done=false;
	
	//Elementi interfaccia:
	GridBagLayout gridBagLayout = new GridBagLayout();
	
	Label rootLabel = new Label("Dominio di Root?");
  CheckboxGroup checkboxGroup = new CheckboxGroup();
  Checkbox yesCheck = new Checkbox("Si",false,checkboxGroup);
  Checkbox noCheck = new Checkbox("No",true,checkboxGroup);
	
	//da eliminare:
	Label portLabel=new Label("Porta del server");
	TextField portField=new TextField(20);
	/////
  Label domNameLabel = new Label("Nome del Dominio");
  Label pardomNameLabel = new Label("Nome del dominio superiore");
  Label pardomHostLabel = new Label("Host NS superiore");
  //da eliminare:
	Label pardomPortLabel = new Label("Porta NS superiore (temp.)");
	/////
	Label rootHostLabel = new Label("Host NS Root");
  //da eliminare:
	Label rootPortLabel = new Label("Porta NS Root (temp.)");
	////
  Label ttlLabel = new Label("TimeToLive Dominio");
	Label outputLabel = new Label();
	
	TextField domNameField = new TextField(20);
  TextField pardomNameField = new TextField(20);
  TextField pardomHostField = new TextField(20);
	TextField rootHostField = new TextField(20);
  //da eliminare:
	TextField pardomPortField = new TextField(10);
  TextField rootPortField = new TextField(10);
	/////
  TextField ttlField = new TextField(10);
  Button okButton = new Button("OK");
  
	Frame frame;
	
	public PrimaryInitGui(File file){
		frame=new Frame("Inizializzazione Server Primario");
		this.file=file;
		frame.addWindowListener(this);
	}
	
	public void run(){
		frame.setSize(new Dimension(400, 300));

    frame.setLayout(gridBagLayout);

		yesCheck.addItemListener(this);
		noCheck.addItemListener(this);

    frame.add(rootLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    frame.add(yesCheck, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    frame.add(noCheck, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
		
		
		frame.add(portLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(portField, new GridBagConstraints(1, 1, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(domNameLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(domNameField, new GridBagConstraints(1, 2, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(pardomNameField, new GridBagConstraints(1, 3, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(pardomNameLabel, new GridBagConstraints(0, 3, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(pardomHostLabel, new GridBagConstraints(0, 4, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(pardomPortLabel, new GridBagConstraints(0, 5, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
		frame.add(rootHostLabel, new GridBagConstraints(0, 6, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(rootPortLabel, new GridBagConstraints(0, 7, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(ttlLabel, new GridBagConstraints(0, 8, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    frame.add(pardomHostField, new GridBagConstraints(1, 4, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(pardomPortField, new GridBagConstraints(1,5, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(rootHostField, new GridBagConstraints(1, 6, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(rootPortField, new GridBagConstraints(1, 7, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
		frame.add(ttlField, new GridBagConstraints(1, 8, 1, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 5), 0, 0));
    frame.add(okButton, new GridBagConstraints(0, 9, 2, 1, 0.5, 0.5
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    frame.add(outputLabel, new GridBagConstraints(0, 10, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));

		okButton.addActionListener(this);
		frame.setResizable(false);
		frame.show();
		while(!done){
			try{
				sleep(500);
			}catch(InterruptedException e){
				continue;
			}
		}
	}
	
	public void actionPerformed(ActionEvent e){
		try{
			Domain dom;
			Domain pardom;
			Table table;
			Binding parns;
			Binding rootns;
			int servPort;
			if (checkboxGroup.getSelectedCheckbox().equals(noCheck)) {
				dom=new Domain(domNameField.getText());
				servPort=Integer.parseInt(portField.getText());
				pardom=new Domain(pardomNameField.getText());
				if (!dom.startsWith(pardom)) throw new javax.naming.InvalidNameException();
				table=new Table();
				parns=new Binding(new NSName(pardom),new Value(InetAddress.getByName(pardomHostField.getText()),Integer.parseInt(pardomPortField.getText())));
				table.put(parns);
				rootns=new Binding(new NSName(Domain.getRootName()),new Value(InetAddress.getByName(rootHostField.getText()),Integer.parseInt(rootPortField.getText())));
				table.put(rootns);

			} else {
				dom=Domain.getRootName();
				servPort=Integer.parseInt(portField.getText());
				pardom=null;
				table=new Table();
			}
			file.createNewFile();
			ObjectOutputStream oos=new ObjectOutputStream(new FileOutputStream(file));
			oos.writeInt(servPort);
			oos.writeObject(dom);
			if(pardom!=null)oos.writeObject(pardom);
			oos.writeObject(table);
			oos.writeInt(Integer.parseInt(ttlField.getText()));			
			oos.close();	
			frame.dispose();
			done=true;
		}catch(NumberFormatException nfe){
			outputLabel.setText("Formato del numero non corretto.");
		}catch(javax.naming.InvalidNameException ine){
			outputLabel.setText("Nome del dominio non corretto.");
		}catch(UnknownHostException uhe){	
			outputLabel.setText("Impossibile trovare Host.");
		}catch(Exception exc){
			outputLabel.setText("Inserimento dati errato:"+exc.getMessage());
		} 
	}
	
	public void itemStateChanged(ItemEvent e) {
    if (checkboxGroup.getSelectedCheckbox().equals(yesCheck)) {
      domNameField.setEditable(false);
  		pardomNameField.setEditable(false);
  		pardomHostField.setEditable(false);
			rootHostField.setEditable(false);
			pardomPortField.setEditable(false);
  		rootPortField.setEditable(false);
			domNameField.setText("");
  		pardomNameField.setText("");
  		pardomHostField.setText("");
			rootHostField.setText("");
			pardomPortField.setText("");
  		rootPortField.setText("");
		} else {
      domNameField.setEditable(true);
  		pardomNameField.setEditable(true);
  		pardomHostField.setEditable(true);
			rootHostField.setEditable(true);
			pardomPortField.setEditable(true);
  		rootPortField.setEditable(true);
    }
	}
	
	public void windowClosing(WindowEvent evt){}
	public void windowActivated(WindowEvent evt) {}
 	public void windowClosed(WindowEvent evt) {}
	public void windowDeactivated(WindowEvent evt) {}
	public void windowDeiconified(WindowEvent evt) {}
	public void windowIconified(WindowEvent evt) {}
	public void windowOpened(WindowEvent evt) {}

}
