package Dns.Msg;

//Messaggio di risposta per dominio di appartenenza

import java.io.*;
import java.net.*;
import Dns.Domain;

public class DomainAnswerMsg extends AnswerMsg {
	protected transient Domain answ;
	
	//serializzazione dell'oggetto////////////////////////////
	protected DomainAnswerMsg(){
		answ=null;timestamp=0;
	}
	
	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeObject(answ);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		answ=(Domain)in.readObject();
	}
	////////////////////////////////////////////////////////
	
	public DomainAnswerMsg(Domain answ,int timestamp){
		this.answ=answ;
		this.timestamp=timestamp;
	}//costruttore
	
	public Domain getDomain(){
		return answ;
	}//getDoamin
	
	
	public String toString(){
		return answ.toString();
	}

}//class DomainAnswerMsg
