package Dns.Msg;

import java.io.*;

//Meccanismo di Timestamping dei messaggi:

public abstract class TimestampedMsg extends Msg.PacketMsg{
	protected transient int timestamp;
	
	//serializzazione dell'oggetto

	private void writeObject(ObjectOutputStream out) throws IOException {
		out.writeInt(timestamp);
	}
	
	private void readObject(ObjectInputStream in) throws IOException,ClassNotFoundException{
		timestamp=in.readInt();
	}
	
	public int getTimestamp(){
		return timestamp;
	}
	
	public void setTimestamp(int timestamp){
		this.timestamp=timestamp;
	}

}//abstract class TimestampedMsg
