package Dns;

//specializzazione della classe DNSName
//per modellare il nome di un Name Server
import javax.naming.InvalidNameException;
public class NSName extends DNSName{

	public NSName(Domain domain) throws InvalidNameException{
		super(new NSType(),domain);
	}//costruttore
	 
	public NSName(NameParser np) throws InvalidNameException{
		super(new NSType(),np.getDomain());
	}//costruttore
	
	public NSName(String s) throws InvalidNameException{
		super(new NSType(),new Domain(s));
	}//costruttore

}//class NSName
