package Security;


//import javax.crypto.interfaces.RSAPublicKey;
//import javax.crypto.interfaces.RSAPrivateKeyCrt;
import java.security.*;
//import iaik.security.rsa.*;

import com.entrust.util.*;
import iaik.security.rsa.RSAPrivateKey;
import iaik.security.rsa.RSAPublicKey;
//import java.security.KeyPairGenerator;
import java.util.Hashtable;
import java.lang.String;
import java.io.*;
import Security.RSACipher;
import java.lang.Object;


public class chiave{
	RSAPublicKey rsa_pub_key =null;
	RSAPrivateKey rsa_priv_key =null;
	//costruttore genera la coppia di chiavi e le scrive su file
	public chiave()throws Exception{

			System.out.print("inizio   ");
			Util.initCiphers();
			KeyPairGenerator key_gen = KeyPairGenerator.getInstance("RSA");
      	key_gen.initialize(512);
         System.out.print("genero chiavi   ");
			KeyPair key_pair = key_gen.generateKeyPair();
			System.out.println("ok");
         rsa_pub_key = (RSAPublicKey)key_pair.getPublic();			//Chiave pubblica
			rsa_priv_key = (RSAPrivateKey)key_pair.getPrivate(); 		//Chiave privata
			System.out.println("stampo");
			
			//viene effettuata una copia delle chiavi su file
			if (!writePublic("keypbB.txt")) throw new Exception("impossibile creare file");
			if (!writePrivate("keyprB.txt")) throw new Exception("impossibile creare file");
			
			//System.out.println("chiave pubblica  "+rsa_pub_key);					        
			//System.out.println("chiave privata  "+rsa_priv_key);					        
		   
		
	} //endchiave

	//Costruttore con argomento il nome dei file delle chiavi: legge chiavi da  file
	public chiave(String privfile,String pubfile) throws Exception{
			FileInputStream istream = new FileInputStream(privfile);
			ObjectInputStream p = new ObjectInputStream(istream);
			rsa_priv_key=(RSAPrivateKey)p.readObject();
			istream.close();
			p.close();
			istream = new FileInputStream(pubfile);
			p = new ObjectInputStream(istream);
			rsa_pub_key=(RSAPublicKey)p.readObject();
		   istream.close();									 //////7777777777777
			p.close();  										  ////////77777777777
	}
	//Costruttore con argomento il nome del file della chiave pubblica
	public chiave(String pubfile) throws Exception{
			
			FileInputStream istream = new FileInputStream(pubfile);
			ObjectInputStream p = new ObjectInputStream(istream);
			rsa_pub_key=(RSAPublicKey)p.readObject();
		   istream.close();
			p.close(); 
	}



public RSAPublicKey getPublic(){
		return 	rsa_pub_key;
	}
	
public RSAPrivateKey getPrivate(){
		return 	rsa_priv_key;
	}

public boolean writePublic(String nomefile){
		try{
			//creo flussi

			FileOutputStream fostream = new FileOutputStream(nomefile);
			ObjectOutputStream ostream = new ObjectOutputStream(fostream);
			ostream.writeObject(rsa_pub_key);
			ostream.close();
			fostream.close();
			return true;
		} 
		catch (Exception e){
			System.err.println(e.getMessage());
			return false;
		} 
	}
	
	public boolean writePrivate(String nomefile){
		try{
			FileOutputStream fostream = new FileOutputStream(nomefile);
			ObjectOutputStream ostream = new ObjectOutputStream(fostream);
			ostream.writeObject(rsa_priv_key);
			return true;
		} catch (Exception e){
			System.err.println(e.getMessage());
			return false;
		} 
	}
	
	public static RSAPublicKey readPublic(String nomefile) throws Exception{
		FileInputStream istream = new FileInputStream(nomefile);
		ObjectInputStream p = new ObjectInputStream(istream);
		RSAPublicKey key=(RSAPublicKey)p.readObject();
		istream.close();
		p.close();
		return key;
	} 
	
	public static RSAPrivateKey readPrivate(String nomefile) throws Exception{
		FileInputStream istream = new FileInputStream(nomefile);
		ObjectInputStream p = new ObjectInputStream(istream);
		RSAPrivateKey key=(RSAPrivateKey)p.readObject();
		istream.close();
		p.close();
		return key;
	}

/*
public static Hashtable readHashtable(String nomefile) throws Exception{
		FileInputStream istream = new FileInputStream(nomefile);
		ObjectInputStream p = new ObjectInputStream(istream);
		Hashtable ht=(Hashtable)p.readObject();
		istream.close();
		p.close();
		return ht;
	}

*/


}//endchiave


